package cn.com.infosec.openssl;

import cn.com.infosec.crypto.PBEParametersGenerator;
import cn.com.infosec.crypto.generators.OpenSSLPBEParametersGenerator;
import cn.com.infosec.crypto.params.KeyParameter;
import java.io.IOException;
import java.security.spec.AlgorithmParameterSpec;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.RC2ParameterSpec;
import javax.crypto.spec.SecretKeySpec;

final class PEMUtilities {
   static byte[] crypt(boolean encrypt, String provider, byte[] bytes, char[] password, String dekAlgName, byte[] iv) {
      Object var6;
      var6 = new IvParameterSpec.<init>(iv);
      String var7 = "CBC";
      String var8 = "PKCS5Padding";
      if (dekAlgName.endsWith("-CFB")) {
         var7 = "CFB";
         var8 = "NoPadding";
      }

      if (dekAlgName.endsWith("-ECB") || "DES-EDE".equals(dekAlgName) || "DES-EDE3".equals(dekAlgName)) {
         var7 = "ECB";
         var6 = null;
      }

      if (dekAlgName.endsWith("-OFB")) {
         var7 = "OFB";
         var8 = "NoPadding";
      }

      String var9;
      char[] var10000;
      String password1;
      SecretKey dekAlgName2;
      if (dekAlgName.startsWith("DES-EDE")) {
         var10000 = password;
         password1 = "DESede";
         boolean dekAlgName1 = dekAlgName.startsWith("DES-EDE3") ^ true;
         dekAlgName2 = getKey(var10000, password1, 24, iv, dekAlgName1);
         var9 = password1;
      } else if (dekAlgName.startsWith("DES-")) {
         var10000 = password;
         password1 = "DES";
         dekAlgName2 = getKey(var10000, "DES", 8, iv);
         var9 = password1;
      } else if (dekAlgName.startsWith("BF-")) {
         var10000 = password;
         password1 = "Blowfish";
         dekAlgName2 = getKey(var10000, "Blowfish", 16, iv);
         var9 = password1;
      } else if (dekAlgName.startsWith("RC2-")) {
         var9 = "RC2";
         short var10 = 128;
         if (dekAlgName.startsWith("RC2-40-")) {
            var10 = 40;
         } else if (dekAlgName.startsWith("RC2-64-")) {
            var10 = 64;
         }

         dekAlgName2 = getKey(password, var9, var10 / 8, iv);
         if (var6 == null) {
            var6 = new RC2ParameterSpec.<init>(var10);
         } else {
            var6 = new RC2ParameterSpec.<init>(var10, iv);
         }
      } else {
         if (!dekAlgName.startsWith("AES-")) {
            throw new IOException("unknown encryption with private key");
         }

         var9 = "AES";
         if (iv.length > 8) {
            byte[] var22 = iv;
            iv = new byte[8];
            System.arraycopy(var22, 0, iv, 0, 8);
         }

         short var24;
         if (dekAlgName.startsWith("AES-128-")) {
            var24 = 128;
         } else if (dekAlgName.startsWith("AES-192-")) {
            var24 = 192;
         } else {
            if (!dekAlgName.startsWith("AES-256-")) {
               throw new IOException("unknown AES encryption with private key");
            }

            var24 = 256;
         }

         int dekAlgName3 = var24 / 8;
         dekAlgName2 = getKey(password, "AES", dekAlgName3, iv);
      }

      boolean var26 = encrypt;
      String var10001 = var9 + "/" + var7 + "/" + var8;

      Exception var27;
      label101: {
         boolean var23;
         Cipher var25;
         try {
            var25 = Cipher.getInstance(var10001, provider);
         } catch (Exception var14) {
            var27 = var14;
            var23 = false;
            break label101;
         }

         Cipher encrypt1 = var25;
         byte provider1;
         if (var26) {
            provider1 = 1;
         } else {
            provider1 = 2;
         }

         if (var6 == null) {
            try {
               encrypt1.init(provider1, dekAlgName2);
            } catch (Exception var13) {
               var27 = var13;
               var23 = false;
               break label101;
            }
         } else {
            try {
               encrypt1.init(provider1, dekAlgName2, (AlgorithmParameterSpec)var6);
            } catch (Exception var12) {
               var27 = var12;
               var23 = false;
               break label101;
            }
         }

         try {
            return encrypt1.doFinal(bytes);
         } catch (Exception var11) {
            var27 = var11;
            var23 = false;
         }
      }

      Exception encrypt2 = var27;
      throw new IOException("exception using cipher: " + encrypt2.toString());
   }

   private static SecretKey getKey(char[] password, String algorithm, int keyLength, byte[] salt) {
      return getKey(password, algorithm, keyLength, salt, false);
   }

   private static SecretKey getKey(char[] password, String algorithm, int keyLength, byte[] salt, boolean des2) {
      boolean var10000 = des2;
      OpenSSLPBEParametersGenerator des21;
      OpenSSLPBEParametersGenerator var10001 = des21 = new OpenSSLPBEParametersGenerator;
      des21.<init>();
      des21.init(PBEParametersGenerator.PKCS5PasswordToBytes(password), salt);
      byte[] password1 = ((KeyParameter)var10001.generateDerivedParameters(keyLength * 8)).getKey();
      if (var10000 && password1.length >= 24) {
         System.arraycopy(password1, 0, password1, 16, 8);
      }

      return new SecretKeySpec(password1, algorithm);
   }
}
